package jalview.ext.treeviewer;

import java.awt.Dimension;
import java.awt.Graphics2D;
import java.awt.MenuContainer;
import java.awt.Rectangle;
import java.awt.event.MouseListener;
import java.io.File;
import java.util.Set;

import javax.accessibility.Accessible;

public interface TreePanelI extends Accessible, MenuContainer
{


  public abstract void setTreeFile(File file);

  public abstract File getTreeFile();

  public abstract TreeI getTree();

  public abstract TreeNodeI findNode(int x, int y);

  public abstract void setMatchingNodes(Set<Long> matchingNodes);

  public abstract Set<Long> getMatchingNodes();

  public void addMouseListener(MouseListener listener);

  public void removeMouseListener(MouseListener listener);

  public MouseListener[] getMouseListeners();

  public void repaint();

  public void registerWithPaintRefresher(String sequenceSetIdentifier);

  public void notifyPaintRefresher(boolean alignmentChanged,
          boolean validateSequences);

  public void notifyPaintRefresher(String newSeqSetIdentifier,
          boolean alignmentChanged, boolean validateSequences);

  public int getWidth();

  public int getHeight();

  public abstract void paintToFile(Graphics2D pg, int width, int height);

  public boolean showingSubTree();

  public float getPartitionThreshold();

  public abstract Rectangle getVisibleArea();

  public void setMinimumSize(Dimension minimumSize);

  public void setMaximumSize(Dimension maximumSize);

  public void setPreferredSize(Dimension preferredSize);

}
